kotlin协程异常处理之-try catch

一、try catch

try catch是否一定有效呢?未必,来看一下:

1、withContext

import kotlinx.coroutines.*

fun main() = runBlocking {
    launch {
        println("launch start")
        try {
            withContext(Dispatchers.IO) {
                // 可能抛出异常
            }
        } catch (ex: Exception) {
            println("withContext caught: ${ex.message}")
        }
        println("launch end")
    }
}

withContext是一个挂起函数,它会暂停当前协程的执行,等待传递进来的协程上下文切换后继续执行。当在withContext内部发生异常时,异常会被传递回到withContext函数的调用者,也就是当前协程的上一级代码中,进而可以被try-catch块捕获到。

2、launch

import kotlinx.coroutines.*

fun main() = runBlocking {
    try {
        launch {
            println("launch start")
            // 可能抛出异常
            println("launch end")
        }
    } catch (ex: Exception) {
        println("launch caught: ${ex.message}")
    }
}

try {
    GlobalScope.launch {
        throw NullPointerException()
    }
} catch (e :Exception) {
    e.printStackTrace()
}

launch启动的协程是独立于调用它的协程之外的一个新的协程,它没有直接的上级协程来捕获它的异常,因此try-catch在协程外部捕获不到协程中的异常。
事实证明,只要是launch的协程,无论是子协程还是根协程,都无法被捕获。比如:

GlobalScope.launch {
    try {
        launch {
            Log.d("MainActivity_", "launch-> threadName->" + Thread.currentThread().name)
            throw NullPointerException()
        }
    } catch (e :Exception) {
        e.printStackTrace()
    }
}

一样会崩溃。

如果将try catch放于内部:

import kotlinx.coroutines.*

fun main() = runBlocking {
     launch {
         try {
            // 可能抛出异常
         } catch (ex: Exception) {
            println("launch caught: ${ex.message}")
         }
         println("launch end")
	 }
}

这样便可以捕获得到异常了。

3、async

(1)内部async

GlobalScope.launch {
    try {
        val deferredResult: Deferred<Int> = async {
            Log.d("AsyncTest", "throw before")
            throw Exception("async function exception")
            Log.d("AsyncTest", "throw after")
        }
        deferredResult.await()
    } catch (ex: Exception) {
        Log.d("AsyncTest", "${ex.message}")
    }
}

输出:

D/AsyncTest: throw before
D/AsyncTest: async function exception

但是程序奔溃了,可以捕获异常,但是会崩。


(2)、将try catch放于内部:

GlobalScope.launch {
    val deferredResult: Deferred<Int> = async {
        try {
            Log.d("AsyncTest", "throw before")
            throw Exception("async function exception")
            Log.d("AsyncTest", "throw after")
        } catch (e: java.lang.Exception) {
            Log.d("AsyncTest", "${e.message}")
        }
    }
    deferredResult.await()
}

输出:

D/AsyncTest: throw before
D/AsyncTest: async function exception

可以捕获异常,并且程序不会崩溃。


(3)、使用GlobalScope.async

GlobalScope.launch {
    try {
        val deferredResult: Deferred<Int> = GlobalScope.async {
            Log.d("AsyncTest", "throw before")
            throw Exception("async function exception")
            Log.d("AsyncTest", "throw after")
        }
        deferredResult.await()
    } catch (ex: Exception) {
        Log.d("AsyncTest", "${ex.message}")
    }
}

输出:

D/AsyncTest: throw before
D/AsyncTest: async function exception

可以捕获异常,并且程序不会崩溃。


(4)、只对deferredResult.await()try catch

GlobalScope.launch {
    val deferredResult: Deferred<Int> = GlobalScope.async {
        Log.d("AsyncTest", "throw before")
        throw Exception("async function exception")
        Log.d("AsyncTest", "throw after")
    }
    try {
        deferredResult.await()
    } catch (e: Exception) {
        Log.d("AsyncTest", "${e.message}")
    }
}

输出:

D/AsyncTest: throw before
D/AsyncTest: async function exception

可以捕获异常,并且程序不会崩溃。

结论

1、withContext是一个挂起函数,它会暂停当前协程的执行,等待传递进来的协程上下文切换后继续执行。当在withContext内部发生异常时,异常会被传递回到withContext函数的调用者,也就是当前协程的上一级代码中,进而可以被try-catch块捕获到。
2、launch启动的协程是独立于调用它的协程之外的一个新的协程,它没有直接的上级协程来捕获它的异常,因此try-catch在协程外部捕获不到协程中的异常。
3、async如果启动的是子协程,那么代码执行到 throw 异常的时候就抛出了异常,与是否调用await方法无关,这个异常可以用try-catch捕获但是会引起崩溃。
4、async开启一个根协程,在调用await方法时候会抛出异常,这个异常可以用try-catch捕获不引起崩溃。

热门相关:冉冉心动